# -*- encoding: utf-8 -*-

import subprocess
import threading
import sys
import os
import signal
import cv2
import tkinter
import time
import math
import datetime

cmd = ["./uselib.exe", "<address-to-video-source>"]


# open our personal stream
objectTrackingStream = cv2.VideoCapture('<address-to-video-source>') 
parkingSpacesStream = cv2.VideoCapture('<address-to-video-source>') 

objects = []
labelTexts = [] 
parkingSpaces = []
parkingSpaceOccupied = [] # states whether a parking space is occupied or not
parkingSpaceOccupiedCounter = [] # buffer counter to avoid declearing parking spaces occupied or unoccupied too quickly
parkingSpaceCoordinatesBuffer = [] # used only for adding parking spaces

def getCoordinatesHighLow(parkingSpace):
	Xcoordinates = [parkingSpace[0], parkingSpace[2], parkingSpace[4], parkingSpace[6]]
	Ycoordinates = [parkingSpace[1], parkingSpace[3], parkingSpace[5], parkingSpace[7]]

	highestX = 0
	highestY = 0
	lowestX = 999999
	lowestY = 999999

	for coordinate in Xcoordinates:
		if int(coordinate) > highestX:
			highestX = int(coordinate)
		if int(coordinate) < lowestX:
			lowestX = int(coordinate)

	for coordinate in Ycoordinates:
		if int(coordinate) > highestY:
			highestY = int(coordinate)
		if int(coordinate) < lowestY:
			lowestY = int(coordinate)

	return highestX, highestY, lowestX, lowestY

def getCentralPointOfParkingSpace(parkingSpace):
	
	highestX, highestY, lowestX, lowestY = getCoordinatesHighLow(parkingSpace)

	x = (highestX + lowestX)//2
	y = (highestY + lowestY)//2

	#print (str(x) + " " + str(y))

	return x, y

def getCentralPoint(left, right, width, height):
	#a = (int(left)+int(right))//2
	#b = (int(top)+int(bot))//2
	a = int(left) + int(width)//2
	b = int(right) + int(height)//2

	return a, b

def clear():
	emptyvar = os.system('cls')
	
def dataBoxDisplay():

	root = tkinter.Tk()
	
	root.geometry('330x700')
	root.title('Object Tabel')
	
	# car 1 Right 200 Left 300 Width 50 Height 50
	tkinter.Label(root, text='Object', borderwidth=3).grid(row=0,column=0)
	tkinter.Label(root, text='ID', borderwidth=3).grid(row=0,column=1)
	tkinter.Label(root, text='Right', borderwidth=3).grid(row=0,column=2)
	tkinter.Label(root, text='Left', borderwidth=3).grid(row=0,column=3)
	tkinter.Label(root, text='Width', borderwidth=3).grid(row=0,column=4)
	tkinter.Label(root, text='Height', borderwidth=3).grid(row=0,column=5)
	tkinter.Label(root, text='Timer', borderwidth=3).grid(row=0,column=6)
	
	while(True):
		if len(objects) > 0: # only start creating labels if we actually do have objects
			for r in range(len(objects)): # go over all the objects in the objects list
				if len(labelTexts) == 0: # no elements in the list yet, let's add one
					templist = []
					for c in range(5): # create labels in the row
						if c == 0: # we read first two values in a row before we start skipping one, so that's why we have that here
							templist.append(tkinter.Label(root, text=objects[r][c], borderwidth=3))
							templist[-1].grid(row=r+1,column=c)
						templist.append(tkinter.Label(root, text=objects[r][1+2*c], borderwidth=3))
						templist[-1].grid(row=r+1,column=c+1)
						#labelTexts.append((objects[r][1], tkinter.Label(root, text=objects[r][1+2*c], borderwidth=3)))
						#labelTexts[-1][1].grid(row=r+1,column=c+1)
				
					templist.append(tkinter.Label(root, text=str(round(time.time()-objects[r][10])), borderwidth=3))
					templist[-1].grid(row=r+1,column=6)
					labelTexts.append((objects[r][1], templist)) # store them as pairs, so we know to which object a specific label list corresponds to
					break

				for pair in labelTexts: # check if we already have an ID and list of labels pair stored 
					if pair[0] == objects[r][1]: # we have found such pair
						pair[1][0].configure(text=objects[r][0]) # once again, set the first label
						for i in range(0,5): # update all the label texts in there
							pair[1][i+1].configure(text=objects[r][1+2*i])
						pair[1][6].configure(text=str(round(time.time()-objects[r][10])))
						break

					elif pair == labelTexts[len(labelTexts)-1]: # we didn't find such pair, so it must be a new object
						templist = []
						for c in range(5): # create labels in the row
							if c == 0: # we read first two values in a row before we start skipping one, so that's why we have that here
								templist.append(tkinter.Label(root, text=objects[r][c], borderwidth=3))
								templist[-1].grid(row=r+1,column=c)
							templist.append(tkinter.Label(root, text=objects[r][1+2*c], borderwidth=3))
							templist[-1].grid(row=r+1,column=c+1)

						templist.append(tkinter.Label(root, text=str(round(time.time()-objects[r][10])), borderwidth=3))
						templist[-1].grid(row=r+1,column=6)
						labelTexts.append((objects[r][1], templist)) # store them as pairs, so we know to which object a specific label list corresponds to
						break

			for obj in objects:
				a = time.time()
				if round(a-obj[10]) > 6: # we have not seen the object for over 6 seconds
					#print ("Removed object " + str(obj[1]) + " from list")
					
					objects.remove(obj) # remove it from objects list
					for pair in labelTexts:
						if pair[0] == obj[1]:
							for label in pair[1]:
								label.destroy()
							labelTexts.remove(pair)
							break

					
					
			root.update()
			
			#for label in root.winfo_children():
			#	label.destroy()
		
	
def objectExists(objectID): # check if we already have such an object in the list
	for i in range(len(objects)):
		if objectID == objects[i][1]:
			return i # we do, return the ID so we could update it
	return -1
	
def checkForUpdatedID(object): # check if the ID changed for a known object
	pass 

def printObjects():
	while(True):
		for obj in objects:
			print (obj)

		#print ("\n\n\n\n")
		#for pair in labelTexts:
		#	print(pair)
		clear()
		
def isDuplicate(newObject): # quite often the network thinks a previously known object is now a different object and gives it a new ID. Here we will try to determine if that's the case, so instead of adding a new object, we simply update the ID of the same object
	# basically we compare the location of the new object with every other known object
	for i in range(len(objects)):
		#print (object)
		#print (newObject)
		if abs(int(objects[i][3]) - int(newObject[3])) < 10 and abs(int(objects[i][5]) - int(newObject[5])) < 10:
			return i
			
	return False

def determineCoordinates(space):
	Xcoordinates = [int(space[0]), int(space[2]), int(space[4]), int(space[6])]
	Ycoordinates = [int(space[1]), int(space[3]), int(space[5]), int(space[7])]

	# we need to find where the 4 points are and mark them, so we know what we are doing

	crd1 = "" # top left
	crd2 = "" # top right
	crd3 = "" # bottom left
	crd4 = "" # bottom right

	rankingX = Xcoordinates[:]
	rankingY = Ycoordinates[:]

	rankingX.sort()
	rankingY.sort()

	if rankingY.index(Ycoordinates[Xcoordinates.index(rankingX[0])]) < rankingY.index(Ycoordinates[Xcoordinates.index(rankingX[1])]):
		crd1 = (rankingX[0], Ycoordinates[Xcoordinates.index(rankingX[0])])
		crd3 = (rankingX[1], Ycoordinates[Xcoordinates.index(rankingX[1])])
	else:
		crd3 = (rankingX[0], Ycoordinates[Xcoordinates.index(rankingX[0])])
		crd1 = (rankingX[1], Ycoordinates[Xcoordinates.index(rankingX[1])])

	if rankingY.index(Ycoordinates[Xcoordinates.index(rankingX[2])]) < rankingY.index(Ycoordinates[Xcoordinates.index(rankingX[3])]):
		crd2 = (rankingX[2], Ycoordinates[Xcoordinates.index(rankingX[2])])
		crd4 = (rankingX[3], Ycoordinates[Xcoordinates.index(rankingX[3])])
	else:
		crd4 = (rankingX[2], Ycoordinates[Xcoordinates.index(rankingX[2])])
		crd2 = (rankingX[3], Ycoordinates[Xcoordinates.index(rankingX[3])])

	#print ("A " + str(crd1) + " B " + str(crd2) + " C " + str(crd3) + " D " + str(crd4))
	return crd1, crd2, crd3, crd4


def findTriangleArea(line1, line2, line3):
	# We use Heron's formula

	s = (line1 + line2 + line3) / 2
	area = (s * (s-line1) * (s-line2) * (s-line3)) ** 0.5

	return area

def checkForOccupiedParkingSpaces():
	while(True):
		time.sleep(0.5) # need this, else all the math here will overload everything and hinder the performance
		if len(objects) > 0 and len(parkingSpaces) > 0: # only bother checking if we actually have objects and parking spaces
			# it's not clear what's the best way to check if a space is taken, for the moment we will check 5-15 pixels above the lowest part of an object and see if it is with in a previously marked parking space
			# ideally we could check the mid point of an object, but it would only work if we were to look at a parking lot directly from above

			for space in parkingSpaces:
				# the coordinates marking the parking space are not guaranteed to be in any particular order, we need to figure it out
				A, B, C, D = determineCoordinates(space) # let's use classical letters from math books to mark the points of the quadrilateral

				# find the area of the quadrilateral
				AB = math.sqrt((B[0] - A[0])**2 + (B[1] - A[1])**2) 
				BD = math.sqrt((D[0] - B[0])**2 + (D[1] - B[1])**2)
				DC = math.sqrt((C[0] - D[0])**2 + (C[1] - D[1])**2)
				CA = math.sqrt((A[0] - C[0])**2 + (A[1] - C[1])**2)
				CB = math.sqrt((B[0] - C[0])**2 + (B[1] - C[1])**2)

				triangleArea1 = findTriangleArea(AB, CB, CA)
				triangleArea2 = findTriangleArea(BD, DC, CB)
				quadArea = triangleArea1 + triangleArea2
				occupied = False

				if isinstance(quadArea, complex): # sometimes we get a complex type number, let's just ignore those for now
					break

				for obj in objects:
					# extract positional information of an object
					left = int(obj[5])
					right = int(obj[3])
					width = int(obj[7])
					height = int(obj[9])

					# let's find the "ground" of the object and lift it a bit up and shorten it
					leftX = right + 40
					leftY = left + height - 10
					rightX = right + width - 40
					rightY = leftY

					P1 = (leftX, leftY)
					P2 = (rightX, rightY)

					# calculate triangle areas for every edge of quadrilateral where object's ground points form a triangle with the edges
					AP1 = math.sqrt((P1[0] - A[0])**2 + (P1[1] - A[1])**2)
					BP1 = math.sqrt((P1[0] - B[0])**2 + (P1[1] - B[1])**2)
					CP1 = math.sqrt((P1[0] - C[0])**2 + (P1[1] - C[1])**2)
					DP1 = math.sqrt((P1[0] - D[0])**2 + (P1[1] - D[1])**2)

					ABP1 = findTriangleArea(AB, AP1, BP1)
					ACP1 = findTriangleArea(CA, AP1, CP1)
					BDP1 = findTriangleArea(BD, BP1, DP1)
					CDP1 = findTriangleArea(DC, CP1, DP1)

					totalObjectArea = ABP1 + ACP1 + BDP1 + CDP1

					if isinstance(totalObjectArea, complex):
						break

					if totalObjectArea <= quadArea: # space is occupied
						occupied = True
						if parkingSpaceOccupiedCounter[parkingSpaces.index(space)] >= 4: 
							if parkingSpaceOccupied[parkingSpaces.index(space)]: # we already have the parking space marked as occupied, only update the ID to avoid updating the timestamp
								parkingSpaceOccupied[parkingSpaces.index(space)] = (obj[1], parkingSpaceOccupied[parkingSpaces.index(space)][1])
							else:
								parkingSpaceOccupied[parkingSpaces.index(space)] = (obj[1], time.time()) # space is occupied, write the ID of the object occupying the space and the timestamp
						elif parkingSpaceOccupiedCounter[parkingSpaces.index(space)] < 4: 
							parkingSpaceOccupiedCounter[parkingSpaces.index(space)]+=1
							#print (str(parkingSpaces.index(space)) + ": " + str(parkingSpaceOccupiedCounter[parkingSpaces.index(space)]))
						# one part is already in, no need to check for the other side
					else:
						AP2 = math.sqrt((P2[0] - A[0])**2 + (P2[1] - A[1])**2)
						BP2 = math.sqrt((P2[0] - B[0])**2 + (P2[1] - B[1])**2)
						CP2 = math.sqrt((P2[0] - C[0])**2 + (P2[1] - C[1])**2)
						DP2 = math.sqrt((P2[0] - D[0])**2 + (P2[1] - D[1])**2)

						ABP2 = findTriangleArea(AB, AP2, BP2)
						ACP2 = findTriangleArea(CA, AP2, CP2)
						BDP2 = findTriangleArea(BD, BP2, DP2)
						CDP2 = findTriangleArea(DC, CP2, DP2)

						totalObjectArea2 = ABP2 + ACP2 + BDP2 + CDP2
						
						if isinstance(totalObjectArea2, complex):
							break

						if totalObjectArea2 <= quadArea: # space is occupied
							occupied = True
							if parkingSpaceOccupiedCounter[parkingSpaces.index(space)] >= 4:
								if parkingSpaceOccupied[parkingSpaces.index(space)]: # we already have the parking space marked as occupied, only update the ID to avoid updating the timestamp
									parkingSpaceOccupied[parkingSpaces.index(space)] = (obj[1], parkingSpaceOccupied[parkingSpaces.index(space)][1])
								else:
									parkingSpaceOccupied[parkingSpaces.index(space)] = (obj[1], time.time()) # space is occupied, write the ID of the object occupying the space and the timestamp
							elif parkingSpaceOccupiedCounter[parkingSpaces.index(space)] < 4:
								parkingSpaceOccupiedCounter[parkingSpaces.index(space)]+=1
								#print (str(parkingSpaces.index(space)) + ": " + str(parkingSpaceOccupiedCounter[parkingSpaces.index(space)]))

				if not occupied:
					if parkingSpaceOccupiedCounter[parkingSpaces.index(space)] <= 0:
						parkingSpaceOccupied[parkingSpaces.index(space)] = False # nothing was inside, declear this space liberated!
					elif parkingSpaceOccupiedCounter[parkingSpaces.index(space)] > 0: # only keep decreasing the counter while we still consider the space occupied
						parkingSpaceOccupiedCounter[parkingSpaces.index(space)]-=1
						#print (str(parkingSpaces.index(space)) + ": " + str(parkingSpaceOccupiedCounter[parkingSpaces.index(space)]))
		

def readParkingSpaces():
	try:
		f = open("parkingSpaces.txt", "r")
		for line in f:
			temp = line.strip("\n").split(",")
			if temp not in parkingSpaces:
				parkingSpaces.append(temp)
				parkingSpaceOccupied.append(False) # at first we will assume they are all unoccupied
				parkingSpaceOccupiedCounter.append(0) # set to zero
				#print (str(parkingSpaces))
		print ("Parking spaces updated.")
	except FileNotFoundError:
		print("parkingSpaces.txt file does not exist yet.")


def mouseMoved(event, x, y, flags, param):
	#print ("X: " + str(x) + " | Y: " + str(y))
	global parkingSpaceCoordinatesBuffer
	if event == cv2.EVENT_LBUTTONUP:
		parkingSpaceCoordinatesBuffer.append((x,y))
		print ("Added coordinates: ",x,y)
		if len(parkingSpaceCoordinatesBuffer) == 4: # slot is marked
			#parkingSpaces.append(parkingSpaceCoordinatesBuffer) # add all 4 coordinates
			f = open("parkingSpaces.txt", "a")
			f.write(str(parkingSpaceCoordinatesBuffer[0][0])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[0][1])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[1][0])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[1][1])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[2][0])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[2][1])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[3][0])+",")
			f.write(str(parkingSpaceCoordinatesBuffer[3][1])+"\n")
			f.close()
			#parkingSpaces.append(parkingSpaceCoordinatesBuffer)
			parkingSpaceCoordinatesBuffer = [] # wipe the buffer	
			print("Parking space added.")
			readParkingSpaces()

	if event == cv2.EVENT_RBUTTONUP:
		parkingSpaceCoordinatesBuffer = []
		print("Buffer wiped")
		
def parkingSpacesHandler():
	readParkingSpaces() # read the file only once outside of loop, because the only time this can ever change is when we add a new space
	while(True):
		ret, frame = parkingSpacesStream.read()

		#print(str(parkingSpaces))

		cv2.setMouseCallback('Parking Spaces', mouseMoved)
		#print (objects)

		for obj in objects: # this is for debugging, it draws blue dots - the dots that we use to check whether an object is in a parking space or not
			# extract positional information of an object
			left = int(obj[5])
			right = int(obj[3])
			width = int(obj[7])
			height = int(obj[9])

			# let's find the "ground" of the object and lift it a bit up and shorten it
			leftX = right + 40
			leftY = left + height - 10
			rightX = right + width - 40
			rightY = leftY

			P1 = (leftX, leftY)
			P2 = (rightX, rightY)
			#cv2.circle(frame,(P1[0],P1[1]),5,(255,0,0), -1)
			#cv2.circle(frame,(P2[0],P2[1]),5,(255,0,0), -1)	
					

		if len(parkingSpaces) > 0:
			#print("Line")
			for space in parkingSpaces:
				x, y = getCentralPointOfParkingSpace(space)
				if parkingSpaceOccupied[parkingSpaces.index(space)]:
					#print (parkingSpaceOccupied[parkingSpaces.index(space)])
					
					timeParked = datetime.datetime.utcfromtimestamp(time.time() - parkingSpaceOccupied[parkingSpaces.index(space)][1]).strftime('%H:%M:%S')
					#print(timeParked)
					cv2.circle(frame, (x,y), 5, (0,0,255), -1)	# the colour picker here is bgr instead of rgb
					cv2.rectangle(frame, (x+10, y-10), (x+140, y+10), (255, 255, 255), cv2.FILLED)
					cv2.putText(frame, str(parkingSpaceOccupied[parkingSpaces.index(space)][0]) + " - " + timeParked, (x+10, y+4), cv2.FONT_HERSHEY_PLAIN, 1, (0,0,0), 2, cv2.LINE_AA)
				else:
					cv2.circle(frame, (x,y), 5, (0,255,0), -1)
		
		cv2.imshow('Parking Spaces', frame)
		#if len(locations) > 0: # we have locations stored

		if cv2.waitKey(1) & 0xFF == ord('q'):
			parkingSpacesStream.release()
			cv2.destroyAllWindows()
			#objectPrinterThread.stop()
			break


def objectTracking():
	while(True):
		ret, frame = objectTrackingStream.read()
		
		if len(objects) > 0: # we have objects with coordinates, let's mark them
			for item in objects:
				x, y = getCentralPoint(item[3], item[5], item[7], item[9])
				cv2.circle(frame,(x,y),5,(127,255,250), -1)	# the colour picker here is bgr instead of rgb
		
		cv2.imshow('Object Tracking', frame)
		
		#if len(locations) > 0: # we have locations stored

		if cv2.waitKey(1) & 0xFF == ord('q'):
			objectTrackingStream.release()
			cv2.destroyAllWindows()
			#objectPrinterThread.stop()
			break

def readDarknetPipe():
	#starter = 0
	#counter = 0
	process = subprocess.Popen(cmd, stdout=subprocess.PIPE)	
	for line in iter(process.stdout.readline, ""):

		#if "Left" in line.decode():
		#	starter = 1

		if "Left" in line.decode(): # only analyse lines that contain the data we want
			object_ = line.decode().strip("\n\r").split()
			resultID = objectExists(object_[1])
			object_.append(time.time())
			if -1 == resultID: # we have not seen this object with this ID yet
				objects.append(object_)
				#duplicateCheck = isDuplicate(object_) # check if it might be a duplicate by checking coordinates
				#if not duplicateCheck:
					
				#else:
				#	print ("Replaced object " + str(objects[duplicateCheck][1]) + " with new ID " + str(object_[1]))
				#	for i in range (len(labelTexts)): # update the ID in label management first
				#		if labelTexts[i][0] == objects[duplicateCheck][1]:
				#			tmp = (object_[1], labelTexts[i][1])
				#			labelTexts[i] = tmp
				#	objects[duplicateCheck] = object_
					#for pair in labelTexts: 
					#	if pair[0] == objects[duplicateCheck][1]:
					#		print (pair[0])
					#		pair[0] = object_[1]
			else:
				#print ("Replaced object " + str(resultID) + " with new ID " + str(object_[1]))
				objects[resultID] = object_ # update
		
		# sys.stdout.write(line.decode())
		# sys.stdout.flush()

parkingSpaceThread = threading.Thread(target=parkingSpacesHandler)
objectTrackerThread = threading.Thread(target=objectTracking)
pipeThread = threading.Thread(target=readDarknetPipe)
objectPrinterThread = threading.Thread(target=printObjects)
dataDisplayThread = threading.Thread(target=dataBoxDisplay)
spaceOccupationCheck = threading.Thread(target=checkForOccupiedParkingSpaces)

parkingSpaceThread.start()
objectTrackerThread.start()
pipeThread.start()
#objectPrinterThread.start()
dataDisplayThread.start()
spaceOccupationCheck.start()
